class Item {
    constructor(name, unitWeight, basePrice, imgFile, key){
        this.name = name;
        this.unitWeight = unitWeight;
        this.basePrice = basePrice;
        this.imgFile = imgFile;
        this.key = key;
    }
};

//instantiate items

var itemTimber = new Item('Timber', 10, 50, 'assets/images/items/itemTimber.png', 'itemTimber');
var itemCotton = new Item('Cotton', 7, 75, 'assets/images/items/itemCotton.png', 'itemCotton');
var itemSalt = new Item('Salt', 7, 100, 'assets/images/items/itemSalt.png', 'itemSalt');
var itemPaper = new Item('Paper', 8, 200, 'assets/images/items/itemPaper.png', 'itemPaper');
var itemTea = new Item('Tea', 8, 300, 'assets/images/items/itemTea.png', 'itemTea');
var itemGunpowder = new Item('Gunpowder', 10, 500, 'assets/images/items/itemGunpowder.png', 'itemGunpowder');
var itemPorcelain = new Item('Porcelain', 12, 800, 'assets/images/items/itemPorcelain.png', 'itemPorcelain');
var itemPerfume = new Item('Perfume', 12, 1000, 'assets/images/items/itemPerfume.png', 'itemPerfume');
var itemSandalwood = new Item('Sandalwood', 15, 1500, 'assets/images/items/itemSandalwood.png', 'itemSandalwood');
var itemSilk = new Item('Silk', 10, 1500, 'assets/images/items/itemSilk.png', 'itemSilk');
var itemJade = new Item('Jade', 12, 2500, 'assets/images/items/itemJade.png', 'itemJade');
var itemRubies = new Item('Rubies', 12, 3000, 'assets/images/items/itemRubies.png', 'itemRubies');


//coin counter
function numberWithCommas(x) {
    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}
var coinCounter = 500;
var coinPeak = coinCounter;


//player inventory -> item: quantity, must init with at least one item:0 
var inventory = {
    itemCotton: 0,
};
var capacityUpgradesCount = 0;
var sailUpgradesCount = 0;

var deadWeightTonnage = 600;
var weightHeader;
var slot0;
var slot1;
var slot2;
var slot3;
var slot4;
var slot5;
var slot6;
var slot7;
var slot8;
var slot9;
var slot10;
var slot11;
var slot12;
var slot13;
var slot14;
var slot15;
var slot16;
var qty0;
var qty1;
var qty2;
var qty3;
var qty4;
var qty5;
var qty6;
var qty7;
var qty8;
var qty9;
var qty10;
var qty11;
var qty12;
var qty13;
var qty14;
var qty15;


var slotArray = [];
slotArray.push(slot1)

function getInventoryWeight(){
    totalWeight = 0
    for (item in inventory){
        totalWeight += this[item].unitWeight * inventory[item];
    };
    return totalWeight
};




//function to render all item images in inventory
function updateInventoryDisplay(){
    //delete item from inventory is qty is zero
    for (item in inventory){
        if(inventory[item] === 0){
            delete inventory[item];
        }
    }

    
    //set slots
    slot0.setTexture(Object.keys(inventory)[0]);
    slot1.setTexture(Object.keys(inventory)[1]);
    slot2.setTexture(Object.keys(inventory)[2]);
    slot3.setTexture(Object.keys(inventory)[3]);
    slot4.setTexture(Object.keys(inventory)[4]);
    slot5.setTexture(Object.keys(inventory)[5]);
    slot6.setTexture(Object.keys(inventory)[6]);
    slot7.setTexture(Object.keys(inventory)[7]);
    slot8.setTexture(Object.keys(inventory)[8]);
    slot9.setTexture(Object.keys(inventory)[9]);
    slot10.setTexture(Object.keys(inventory)[10]);
    slot10.setTexture(Object.keys(inventory)[11]);
    slot10.setTexture(Object.keys(inventory)[12]);
    slot10.setTexture(Object.keys(inventory)[13]);
    slot10.setTexture(Object.keys(inventory)[14]);
    slot10.setTexture(Object.keys(inventory)[15]);

    //set qty display
    qty0.setText(Object.values(inventory)[0]);
    qty1.setText(Object.values(inventory)[1]);
    qty2.setText(Object.values(inventory)[2]);
    qty3.setText(Object.values(inventory)[3]);
    qty4.setText(Object.values(inventory)[4]);
    qty5.setText(Object.values(inventory)[5]);
    qty6.setText(Object.values(inventory)[6]);
    qty7.setText(Object.values(inventory)[7]);
    qty8.setText(Object.values(inventory)[8]);
    qty9.setText(Object.values(inventory)[9]);
    qty10.setText(Object.values(inventory)[10]);
    qty11.setText(Object.values(inventory)[11]);
    qty12.setText(Object.values(inventory)[12]);
    qty13.setText(Object.values(inventory)[13]);
    qty14.setText(Object.values(inventory)[14]);
    qty15.setText(Object.values(inventory)[15]);


};



class inventoryScene extends Phaser.Scene {
    constructor(){
        super({key:'inventoryScene', active: false});
    };


    preload() {
        this.load.image('gridMenu', 'assets/images/gridMenu.png');
        this.load.spritesheet( 'inventoryButtonSprite' , 'assets/images/inventoryButtonSprite.png', {frameWidth:64,frameHeight:64} );
        
        this.load.image('itemTimber', itemTimber.imgFile);
        this.load.image('itemCotton', itemCotton.imgFile);
        this.load.image('itemGunpowder', itemGunpowder.imgFile);
        this.load.image('itemSalt', itemSalt.imgFile);
        this.load.json('priceCurves', 'priceCurves.json');
        


    };

    create() {
        this.priceCurves = this.cache.json.get('priceCurves');
    
        //create inventory Button
        this.inventoryButton = this.add.sprite(16,643,'inventoryButtonSprite').setOrigin(0,0).setFrame(0);
        this.inventoryButton.setInteractive({
                useHandCursor: true
            });

        //toggle inventory group children on inventory button click
        this.inventoryButtonClickCount = 0
        this.inventoryButton.on('pointerdown', function(pointer){
            this.inventoryGroup.toggleVisible();
            this.inventoryButtonClickCount += 1
            this.inventoryButton.setFrame(this.inventoryButtonClickCount % 2);  
            }, this);


        //create inventory group
        this.inventoryGroup = this.add.group();
    
        var grid = this.add.image(174, 374, 'gridMenu');
        var inventoryHeader = this.add.text(128, 240, 'Inventory', {fontFamily: 'dogica_pixelregular', fontSize: '13px', color:'#62232f', stroke: '#62232f'});
        weightHeader = this.add.text(172, 496, '', {fontFamily: 'dogica_pixelregular', fontSize: '13px', color:'#62232f', stroke: '#62232f', align: 'center'}).setOrigin(0.5,0.5);

        var quantityStyle = {fontFamily: 'dogica_pixelregular', fontSize: '13px', color:'#f6efdd', stroke: '#62232f', strokeThickness: 3, align: 'right'};

        qty0 = this.add.text(120, 321).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty1 = this.add.text(175, 321).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty2 = this.add.text(229, 321).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty3 = this.add.text(283, 321).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);

        qty4 = this.add.text(120, 376).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty5 = this.add.text(175, 376).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty6 = this.add.text(229, 376).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty7 = this.add.text(283, 376).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);

        qty8 = this.add.text(120, 431).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty9 = this.add.text(175, 431).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty10 = this.add.text(229, 431).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty11 = this.add.text(283, 431).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);

        qty12 = this.add.text(120, 486).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty13 = this.add.text(175, 486).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty14 = this.add.text(229, 486).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);
        qty15 = this.add.text(283, 486).setStyle(quantityStyle).setOrigin(1,1).setDepth(2);


        slot0 = this.add.image(92, 292);
        slot1 = this.add.image(147, 292);
        slot2 = this.add.image(201, 292);
        slot3 = this.add.image(255, 292);

        slot4 = this.add.image(92, 347);
        slot5 = this.add.image(147, 347);
        slot6 = this.add.image(201, 347);
        slot7 = this.add.image(255, 347);

        slot8 = this.add.image(92, 401);
        slot9 = this.add.image(147, 401);
        slot10 = this.add.image(201, 401);
        slot11 = this.add.image(255, 401);

        slot12 = this.add.image(92, 455);
        slot13 = this.add.image(147, 455);
        slot14 = this.add.image(201, 455);
        slot15 = this.add.image(255, 455);
      
    
        this.inventoryGroup.add(grid);
        this.inventoryGroup.add(inventoryHeader);
        this.inventoryGroup.add(weightHeader);
        this.inventoryGroup.add(slot0);
        this.inventoryGroup.add(slot1);
        this.inventoryGroup.add(slot2);
        this.inventoryGroup.add(slot3);
        this.inventoryGroup.add(slot4);
        this.inventoryGroup.add(slot5);
        this.inventoryGroup.add(slot6);
        this.inventoryGroup.add(slot7);
        this.inventoryGroup.add(slot8);
        this.inventoryGroup.add(slot9);
        this.inventoryGroup.add(slot10);
        this.inventoryGroup.add(slot11);
        this.inventoryGroup.add(slot12);
        this.inventoryGroup.add(slot13);
        this.inventoryGroup.add(slot14);
        this.inventoryGroup.add(slot15);
        this.inventoryGroup.add(qty0);
        this.inventoryGroup.add(qty1);
        this.inventoryGroup.add(qty2);
        this.inventoryGroup.add(qty3);
        this.inventoryGroup.add(qty4);
        this.inventoryGroup.add(qty5);
        this.inventoryGroup.add(qty6);
        this.inventoryGroup.add(qty7);
        this.inventoryGroup.add(qty8);
        this.inventoryGroup.add(qty9);
        this.inventoryGroup.add(qty10);
        this.inventoryGroup.add(qty11);
        this.inventoryGroup.add(qty12);
        this.inventoryGroup.add(qty13);
        this.inventoryGroup.add(qty14);
        this.inventoryGroup.add(qty15);

        this.inventoryGroup.toggleVisible();

        updateInventoryDisplay();


    };

    update() {
        

        //update inventoryWeight display
        weightHeader.setText('Weight: ' + getInventoryWeight() + '/' + deadWeightTonnage + ' tons')



    };

};

